#include "Options.lua"

function init()
	RegisterTool("snowshovel", "Snow shovel", "MOD/vox/shovel.vox")
	SetBool("game.tool.snowshovel.enabled", true)
	--------------------------------------

	
	
	InitialiseVariables()
	
	--------------------------------------
	--------------------------------------
	Target = 0	
	EnableToolCounter  =0							
	FirstEnabledTime = 1
	HardHole = 0
	if Val[DebugMode] then HardHole = Val[HoleRadius] end
	
	
	
	ShowOptions = false
	
end								

function update()								
	if GetString("game.player.tool") == "snowshovel" then	
	if EnableToolCounter > 0 then
	--DebugCross(TargetPos,1,0,0)			
		
		if EnableToolCounter == FirstEnabledTime then
		
			local hit, dist, normal, shape, hitPoint						
			local QueryPos, LocalPos						
		
			for x = -Val[ToolRange],Val[ToolRange],Val[Granularity] do						
			for z = -Val[ToolRange],Val[ToolRange],Val[Granularity] do						
				QueryPos = VecAdd(TargetPos,Vec(x,Val[HeightRange],z))
				hit, dist, normal, shape = QueryRaycast(QueryPos, Vec(0,-1,0), 2*Val[HeightRange])					
				
				if hit then					
				if dist > 0.1 then					
					LocalPos = VecAdd(QueryPos, VecScale(Vec(0,-1,0), dist))		
					LocalPos = VoxelCenter(LocalPos, shape)
					LocalPos = VecAdd(LocalPos, Vec(0,-0.1,0))	
					
					--if Val[PrecisionMode] == false then
						for i = Val[UpwardMin],Val[UpwardMax],Val[UpwardGranular] do			
							local mat = GetShapeMaterialAtPosition(shape, VecAdd(LocalPos,Vec(0,i,0)))		
							
							--DebugPrint ( shape .. " " .. mat)
							if mat == "" then
								--DebugPrint(i)	
								MakeHole(VecAdd(LocalPos,Vec(0,i,0)), Val[HoleRadius],HardHole,HardHole, true)

								break
							else
								--DebugPrint(mat)
							end		
						end			
					--else
						--local mat = GetShapeMaterialAtPosition(shape, VecAdd(LocalPos,Vec(0,i,0)))			
						--if mat == "" then
							--GetPreciseRayCast(LocalPos, 0.3)
						--end
						
					--end
					--DebugCross(LocalPos)				
				end					
				end					

			end						

			end	
			
		end
	end
	
	if EnableToolCounter> 0 then
	EnableToolCounter = EnableToolCounter-1	end
	end
end								

function draw()
	if GetString("game.player.tool") == "snowshovel" then	
	if ShowOptions then
		
		UiMakeInteractive()
		DrawOptions(true)
		
		DrawTargetRange()
	else
		--only add extra showing of outline if not showing already for menu
		if Val[ShowOutLine] then

			CamPos, Camdir = GetAim()						
			local hit, dist, normal, shape = QueryRaycast(CamPos, Camdir, Val[MaxRayDist])						

			if hit then	TargetPos = VecAdd(CamPos, VecScale(Camdir, dist)) end
			DrawTargetRange()

		end

	end
	

	end
end

function DrawTargetRange()
		P0 = VecAdd(TargetPos, Vec(-Val[ToolRange], -Val[HeightRange], -Val[ToolRange]))

		P1 = P0
		P2 = VecAdd(P0,Vec(Val[ToolRange]*2, 0,0))
		DrawLine(P1, P2, 1, 1, 1, 0.8)
		P1u = VecAdd(P1,Vec(0, Val[HeightRange]*2,0))
		P2u = VecAdd(P2,Vec(0, Val[HeightRange]*2,0))
		DrawLine(P1, P1u, 1, 1, 1, 0.8)
		DrawLine(P1u, P2u, 1, 1, 1, 0.8)
		
		P1 = P2
		P2 = VecAdd(P0,Vec(Val[ToolRange]*2, 0,Val[ToolRange]*2))
		DrawLine(P1, P2, 1, 1, 1, 0.8)
		P1u = VecAdd(P1,Vec(0, Val[HeightRange]*2,0))
		P2u = VecAdd(P2,Vec(0, Val[HeightRange]*2,0))
		DrawLine(P1, P1u, 1, 1, 1, 0.8)
		DrawLine(P1u, P2u, 1, 1, 1, 0.8)
		
		P1 = P2
		P2 = VecAdd(P0,Vec(0, 0,Val[ToolRange]*2))
		DrawLine(P1, P2, 1, 1, 1, 0.8)
		P1u = VecAdd(P1,Vec(0, Val[HeightRange]*2,0))
		P2u = VecAdd(P2,Vec(0, Val[HeightRange]*2,0))
		DrawLine(P1, P1u, 1, 1, 1, 0.8)
		DrawLine(P1u, P2u, 1, 1, 1, 0.8)
		
		P1 = P2
		P2 = P0
		DrawLine(P1, P2, 1, 1, 1, 0.8)
		P1u = VecAdd(P1,Vec(0, Val[HeightRange]*2,0))
		P2u = VecAdd(P2,Vec(0, Val[HeightRange]*2,0))
		DrawLine(P1, P1u, 1, 1, 1, 0.8)
		DrawLine(P1u, P2u, 1, 1, 1, 0.8)
end

--not useful did not work
function GetPreciseRayCast(OrigLocalPos, QueryOffset)
	QueryPos = VecAdd(OrigLocalPos,Vec(0,QueryOffset,0))
	local hit, dist, normal, shape = QueryRaycast(QueryPos, Vec(0,-1,0), 2*QueryOffset)

	local OrigDist = dist
	
	local i, mat, LocalPos
	
	--------------------------------------
	for i = Val[UpwardMax]+1,Val[UpwardMin]-0.5,-Val[UpwardGranular] do	
		hit, dist, normal, shape = QueryRaycast(QueryPos, Vec(0,-1,0), 2*QueryOffset)
				
		LocalPos = VecAdd(QueryPos, VecScale(Vec(0,-1,0), dist))		

		local mat = GetShapeMaterialAtPosition(shape, LocalPos)		

		if mat == "" then
			MakeHole(LocalPos, Val[HoleRadius],HardHole,HardHole, true)
		end
		if dist ~= OrigDist then return end
	end		
end

function tick()								
	if GetString("game.player.tool") == "snowshovel" then				
		if InputPressed("usetool") then	
		if ShowOptions == false then
			CamPos, Camdir = GetAim()						
			local hit, dist, normal, shape = QueryRaycast(CamPos, Camdir, Val[MaxRayDist])						

			if hit then						
				TargetPos = VecAdd(CamPos, VecScale(Camdir, dist))																		
				EnableToolCounter = FirstEnabledTime					
			end						
		end
		end

		if Val[ContinuousMode] then 
		if InputDown("usetool") then
		if ShowOptions == false then

			
				CamPos, Camdir = GetAim()						
				local hit, dist, normal, shape = QueryRaycast(CamPos, Camdir, Val[MaxRayDist])						

				if hit then						
					TargetPos = VecAdd(CamPos, VecScale(Camdir, dist))																		
					EnableToolCounter = FirstEnabledTime					
				end						
		end
		end	
		end
		
		if InputPressed("m") then	
			ShowOptions = not(ShowOptions)
			
			if ShowOptions then
				CamPos, Camdir = GetAim()						
				local hit, dist, normal, shape = QueryRaycast(CamPos, Camdir, Val[MaxRayDist])						

				if hit then						
					TargetPos = VecAdd(CamPos, VecScale(Camdir, dist))																							
				end	
			end
			
		end
		if ShowOptions then
		if InputPressed("esc") then	
			ShowOptions = not(ShowOptions)
		end
		end
	
	end						
end								

function GetAim(range)								
	local ct = GetCameraTransform()							
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -1))							
    local direction = VecSub(forwardPos, ct.pos)								
	local direction = VecNormalize(direction)							

	return ct.pos, direction							
end								
						

function VoxelCenter(worldpos, shape)								
	local loc = TransformToLocalPoint(GetShapeWorldTransform(shape), worldpos)							
	loc = VecScale(loc, 10)							
	loc = Vec(math.floor(loc[1])+0.5, math.floor(loc[2])+0.5, math.floor(loc[3])+0.5)							
	loc = VecScale(loc, 0.1)							
	worldpos = TransformToParentPoint(GetShapeWorldTransform(shape), loc)							
	return worldpos							
end								
