
function InitialiseVariables()
	Default= {} --Default values
	Val = {} --Current values
	UiName = {} --Name shown on UiAlign
	TextBox = {} --Helping text for setting
	TextHeight = {} --user gives in rows how long the text is, which is converted to pixels later
	MinVal = {} --Min Slider value
	MaxVal = {} --Max Slider value
	Unit = {} --unit shown in display
	UnitFactor = {} --displayed value only is multiplied by this number
	Rounding = {} --how many decimals to keep
	
	local i = 0
	--Initialise each variable
	i = i + 1
		BasicSettings = i
		Default[i] = "Basic settings"
		
	i = i + 1
		HeightRange = i
		Default[i] = 0.2
		UiName[i] = "Size up & down"
		TextBox[i] = "It is looking for the first voxel (on top) from this many meters up, to this many meters down. If too high it results in more lag and less accurate snow removal (leaving more)."
		TextHeight[i] = 4
		MinVal[i] = 0.05
		MaxVal[i] = 10
		Unit[i] = "m"
		UnitFactor[i] = 1
		Rounding[i] = 1
	i = i + 1
		ToolRange = i
		Default[i] = 0.3
		UiName[i] = "Size sideways"
		TextBox[i] = "Removing snow in a square this wide in all 4 directions. (increases lag)"
		TextHeight[i] = 2
		MinVal[i] = 0.05
		MaxVal[i] = 20
		Unit[i] = "m"
		UnitFactor[i] =1
		Rounding[i] = 1
	i = i + 1
		ShowOutLine = i
		Default[i] = false
		UiName[i] = "Show size"
		TextBox[i] = "If enabled, the removal area is constantly shown in game. (it is still visible in the menu without)"
		TextHeight[i] = 2
	i = i + 1
		ContinuousMode = i
		Default[i] = false
		UiName[i] = "Continuous mode"
		TextBox[i] = "If enabled, holding the mouse rather than clicking can be used to remove snow. Be aware: use smaller options as this is bad for frame rates. Auto adjusts some settings down when enabled not to affect frame rates too much. (they can be adjusted back after enabling)"
		TextHeight[i] = 5
	i = i + 1
		MaxRayDist = i
		Default[i] = 20
		UiName[i] = "Max distance"
		TextBox[i] = "Maximum distance for removal. High values lead to bad frame rates if the " .. UiName[ShowOutLine] .. " setting is enabled"
		TextHeight[i] = 3
		MinVal[i] = 1
		MaxVal[i] = 200
		Unit[i] = "m"
		UnitFactor[i] = 1
		Rounding[i] = 0
		
	i = i + 1
		AdvancedSettings = i
		Default[AdvancedSettings] = "Advanced Settings"
	i = i + 1
		DebugMode = i
		Default[i] = false
		UiName[i] = "Debug mode"
		TextBox[i] = "Enable this when playing around with the advanced settings. It makes the mod also remove hard materials that are in range, thus making it easier to find too aggressive settings that would remove more voxels than snow only (esp hole size)"
		TextHeight[i] = 5
	i = i + 1
		HoleRadius = i
		Default[i] = 0.06
		UiName[i] = "Hole size"
		TextBox[i] = "Radius of the hole created at the point of snow voxels. Too small and a lot of snow is left, too big and other soft materials may be removed, not just snow."
		TextHeight[i] = 4
		MinVal[i] = 0.04
		MaxVal[i] = 0.2
		Unit[i] = " voxel"
		UnitFactor[i] = 10
		Rounding[i] = 3
	i = i + 1
		Granularity = i
		Default[i] = 0.04
		UiName[i] = "Granularity (horizontal)"
		TextBox[i] = "How closely individual points of check are placed next to each other. If too small, increases lag. If too large bits of snow are missed in a regular sideways pattern. 0.6 voxel is a good value."
		TextHeight[i] = 4
		MinVal[i] = 0.01
		MaxVal[i] = 0.2
		Unit[i] = " voxel"
		UnitFactor[i] = 10
		Rounding[i] = 2
		
	i = i + 1
		UpwardMin = i
		Default[i] = -0.1
		UiName[i] = "Upward min offset"
		TextBox[i] = "Checking for snow a bit below and above the raycast hit point, as the raycast hit point usually is not enough to find it. Min value is how much below it checks"
		TextHeight[i] = 4
		MinVal[i] = -0.15
		MaxVal[i] = 0
		Unit[i] = " voxel"
		UnitFactor[i] = 10
		Rounding[i] = 2
	i = i + 1
		UpwardMax = i
		Default[i] = 0.1
		UiName[i] = "Upward max offset"
		TextBox[i] = "Checking for snow a bit below and above the raycast hit point, as the raycast hit point usually is not enough to find it. Max value is how much above it checks"
		TextHeight[i] = 4
		MinVal[i] = 0
		MaxVal[i] = 0.15
		Unit[i] = " voxel"
		UnitFactor[i] = 10
		Rounding[i] = 2
	i = i + 1
		UpwardGranular = i
		Default[i] = 0.01
		UiName[i] = "Upward granularity"
		TextBox[i] = "Checking for snow a bit below and above the raycast hit point, as the raycast hit point usually is not enough to find it. " .. UiName[Granularity] .. " is the step size. Smaller numbers increase lag. Decrease if large flat areas of snow are completely missed."
		TextHeight[i] = 5
		MinVal[i] = 0.01
		MaxVal[i] = 0.1
		Unit[i] = " voxel"
		UnitFactor[i] = 10
		Rounding[i] = 3
	--i = i + 1
		--PrecisionMode = i
		--Default[i] = false
		--UiName[i] = "Precision mode (not working)"
		--TextBox[i] = "Reduces performance. Checks with raycasts to make sure the snow is indeed removed. Did not help in testing."

	--------------------------------------------------------------------------------------------
	
	for i = 1,#Default,1 do
		--If has saved value then use that otherwise default
		if HasKey("savegame.mod.Val" .. i) then 
			if type(Default[i]) == "number" then
				Val[i] = GetFloat("savegame.mod.Val" .. i)
			elseif type(Default[i]) == "boolean" then
				Val[i] = GetBool("savegame.mod.Val" .. i)
			end
		else
			Val[i] = Default[i]
		end
		
		--for headers UiName is left empty and is taken from the default value (done like this so default is string type there)
		if UiName[i] == nil then
			UiName[i] = Default[i]
		end
		
		--text height to pixel conversion
		if TextHeight[i] ~= nil then
			TextHeight[i] = TextHeight[i]*28 + 14
		end 
	end
end


function init()
	InitialiseVariables()

	ModMenu = true
end

function draw()
	if ModMenu ~= nil then
		DrawOptions(false)
	end
end

function DrawOptions(FromGame)
	if FromGame then
		UiPush()
			UiColor(0, 0, 0)
			--UiRect(UiWidth(), UiHeight())

			UiColorFilter(0, 0, 0, 0.7)
			UiRect(700, UiHeight())
		UiPop()
	end
	
	--Var init doesn't work if in init when called from game
	----------------------------
	PopupWidth = 500
	PopupHeight = 100
	

	----------------------------
	
	if FromGame then
		UiTranslate(330, 100)
	else
		UiTranslate(UiCenter(), 100)
	end

	
	UiAlign("center middle")

	UiFont("bold.ttf", 48)
	UiText("Snow shovel")
	--UiFont("regular.ttf", 26)
	--UiTranslate(0, 40)
	--UiText("Extra info")
	UiTranslate(0, 70)
	UiFont("regular.ttf", 26)

	
	
	if FromGame == false then
		UiText("Press M in game to see this menu.")
		UiTranslate(0, 20)
	end
	
	--UiTranslate(-150, 80)	

	
	UiTranslate(-80, 0)
	UiPush()
	
	ContBefore = Val[ContinuousMode]
	
	--Draw the gasic Ui
	for i = 1,#UiName,1 do
		if type(Default[i]) == "string" then
			UiHeader(UiName[i])
		elseif type(Default[i]) == "boolean" then
			Val[i] = UITickBox(UiName[i],Val[i],"Val" .. i)
		elseif type(Default[i]) == "number" then
			Val[i] = UISliderExplain(UiName[i],Val[i],MinVal[i],MaxVal[i],UnitFactor[i],Unit[i],"Val" .. i, Rounding[i])
		end
		
	end
	
	ContAfter = Val[ContinuousMode]
	
	if ContAfter then
		if ContBefore == false then
			if Val[HeightRange] > 0.2 then Val[HeightRange] = 0.2 end
			if Val[ToolRange] > 0.3 then Val[ToolRange] = 0.3 end
			if Val[UpwardGranular] < 0.015 then Val[UpwardGranular] = 0.015 end
			if Val[Granularity] < 0.06 then Val[Granularity] = 0.06 end
		end
	end



	UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
	
	UiTranslate(80, 40)
	if UiTextButton("Close", 80, 40) then
		if FromGame == false then
			Menu()
		else
			ShowOptions = false
		end
	end
	
	UiTranslate(0, 60)
	if UiTextButton("Reset to default", 170, 40) then
		for i = 1,#Default,1 do
			Val[i] = Default[i]
			
			if type(Default[i]) == "number" then
				 SetFloat("savegame.mod.Val" .. i, Val[i])
			elseif type(Default[i]) == "boolean" then
				 SetBool("savegame.mod.Val" .. i,Val[i])
			end
			
		end
	end
	
	----------------------------------------------------------------------------------------
	--TextBoxes
	

	UiPop()
	--relative position of question box: 
	UiTranslate(15, -10)
	for i = 1,#UiName,1 do
		UiTranslate(0, 40)
		--Debug the rectanbles where you can get popup
		--UiRect(22, 22)
		if TextBox[i] ~=nil then
		if UiIsMouseInRect(22, 22) then
			UiPush()
				UiColor(1, 1, 1)
				UiTranslate(PopupWidth/2+10,TextHeight[i]/2+10)
				UiRect(PopupWidth, TextHeight[i])
				UiColor(0.1, 0.1, 0.1)
				UiRect(PopupWidth-4, TextHeight[i]-4)

				
				UiWordWrap(PopupWidth-30)
				--UiTranslate(-40,35)
				UiColor(1, 1, 1)
				UiText(TextBox[i])
			UiPop()
		end
		end
	end
end


function UISliderExplain(TextB,CurrentVal,MinV,MaxV,UnitFactor,Unit,SaveName, decim)
	local Result = 0
	UiTranslate(0, 40)
	UiPush()
		TextWithPopup(TextB, true)
		
		
		--
		UiTranslate(250+15, 0)
		
	
		Result, done = optionsSlider(CurrentVal, MinV, MaxV, decim)
		UiTranslate(40, 0)
		UiAlign("left")
		UiColor(0.7, 0.6, 0.1)
		UiText(Result*UnitFactor..Unit)
		SetFloat("savegame.mod."..SaveName, Result)
	UiPop()	
	return Result
end

function UiHeader(TextB)
	local Result = 0
	UiTranslate(0, 40)
	UiPush()
		UiFont("bold.ttf", 26)
		TextWithPopup(TextB, false)
	UiPop()	
	return Result
end

function UITickBox(TextB,CurrentVal,SaveName)
	local Result = 0
	UiTranslate(0, 40)
	UiPush()
		TextWithPopup(TextB, true)
		
		
		--
		UiTranslate(40, 0)
		
		Result = CurrentVal
		UiButtonImageBox("ui/common/box-outline-6.png", 6, 6)
		if UiTextButton(" ", 25, 25) then
			Result = not(CurrentVal)
			SetBool("savegame.mod."..SaveName, Result)
		end
		
		
		UiPush()
			--UiColor(0.7, 0.6, 0.1)
			UiFont("bold.ttf", 26)
			UiColor(0.2, 0.6, 1)
			if Result then UiText("X") end
		UiPop()
		

		
	UiPop()	
	return Result
end

function TextWithPopup(Text, HasPopup)
	--text
	UiAlign("right")
	UiText(Text)
		
	UiTranslate(23, 0)

		--question mark
	if HasPopup then
		UiPush()
		UiTranslate(0,-17)
		UiColor(0.3, 0.3, 0.3)
		UiRect(20, 20)

		UiPop()
		
		UiPush()
		UiColor(1, 1, 1)
		UiFont("bold.ttf", 26)
		UiTextButton("?")
		UiPop()
	end
end


function optionsSlider(val, min, max, decima)
	UiColor(0.2, 0.6, 1)
	UiPush()
		UiTranslate(0, -8)
		val = (val-min) / (max-min)
		local w = 250
		UiRect(w, 3)
		UiAlign("center middle")
		UiTranslate(-w, 1)
		val = UiSlider("ui/common/dot.png", "x", val*w, 0, w) / w
		val = round((val*(max-min)+min), decima)
		if val < min then val = min end
		if val > max then val = max end
		
	UiPop()
	return val
end

function round(number, decimals)
    local power = 10^decimals
	local lowerRound = 0
	local highherRound = 0
	
	lowerRound = math.floor(number * power) / power
	highherRound = math.ceil(number * power) / power
	
	floorerror =  math.abs(number - lowerRound)							
	ceilingerror =  math.abs(number - highherRound)
	
								
	if floorerror < ceilingerror then							
		return lowerRound						
	else							
		return highherRound						
	end		
end